// src/backend/statistics.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef STATISTICS_HH
#define STATISTICS_HH 1

#include <sgpemv2/sgpemv2-visibility.hh>
#include <sgpemv2/templates/singleton.hh>
#include <sgpemv2/process_statistics.hh>
#include <sgpemv2/simulation_statistics.hh>
#include <vector>

#include <glibmm/ustring.h>

namespace sgpem
{
	class Statistics;
	class ConcreteStatistics;

	class SG_DLLEXPORT Statistics  : public Singleton<ConcreteStatistics>
	{
	public:		
		virtual ~Statistics() = 0;
		static Statistics& get_instance();		
		
		virtual void									calculateStatisticsAt(const int& instant) = 0;
		
		virtual std::vector<const ProcessStatistics*>	get_process_statistics() const = 0;
		virtual const SimulationStatistics*			get_simulation_statistics() const = 0;
 
	protected:
	
		Statistics(); // Constructor

	};
}

#endif


