// src/backend/sgpemv2/thread_statistics.hh - Copyright 2005, 2006, University
//               of Padova, dept. of Pure and Applied
//               Mathematics
//
// This file is part of SGPEMv2.
//
// This is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// SGPEMv2 is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with SGPEMv2; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA

#ifndef THREAD_STATISTICS_HH
#define THREAD_STATISTICS_HH 1

#include <sgpemv2/sgpemv2-visibility.hh>

#include <sgpemv2/schedulable_statistics.hh>
#include <sgpemv2/thread.hh>

#include <glibmm/ustring.h>


namespace sgpem
{
  class ThreadStatistics : public SchedulableStatistics
  {
    public:			
      ~ThreadStatistics();

      int               get_execution_time() const =0;
      int               get_execution_progress() const =0;
      int               get_total_inactivity() const =0;
      int               get_response_time() const =0;
      int               get_turn_around() const =0;			
      int               get_efficiency() const =0;
      int               get_resource_usage_time() const =0;
      int               get_resource_waitings_time() const =0;

      const Thread*     get_core() const =0;
      
      /** \brief Useful for ProcessStatistics 
       * \return The first instant at which the thread was first
       * given the processor
       */
      virtual int       get_real_arrival_time() const =0;	

    protected:
      ThreadStatistics();
  };
}

#endif
